PROGRAM_NAME='BSS'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

//MUST ASSIGN [NODE <2 BYTES>, VD <1 BYTE>, OBJECT ID <3BYTES>] (ALWAYS 6 BYTES) FOR EVERY DEVICE!!!!
//GET THIS BY COPY AND PASTING FROM PROPERTIES WINDOW IN BSS AUDIO LONDON ARCHITECT (SEE HELP FILE FOR MORE INFO)
// DO NOT TAKE THIS ADDRESS FROM THE DI-TOOL BAR!! TAKE IT FROM THE PROPERTIES WINDOW OF THE PROCESSING OBJECT

CHAR IO_CARD1[] = {$05,$f1,$03,$00,$00,$01};// I/O CARD SLOT A IS ALWAYS OBJECT ID $00,$00,$01
CHAR IO_CARD2[] = {$05,$f1,$03,$00,$00,$02};// I/O CARD SLOT B IS ALWAYS OBJECT ID $00,$00,$02
CHAR IO_CARD3[] = {$05,$f1,$03,$00,$00,$03};// I/O CARD SLOT C IS ALWAYS OBJECT ID $00,$00,$03
CHAR IO_CARD4[] = {$05,$f1,$03,$00,$00,$04};// I/O CARD SLOT D IS ALWAYS OBJECT ID $00,$00,$04

//This file only shows a couple of example processing objects. 
//The main emphasis is on the Room Combine processing object
//See Infocomm_06 included in this demo for example code for nearly all available processing objects
//See the help file for additional examples
CHAR HALL_A[] =       {$05,$f1,$03,$00,$01,$00};//ROOM_COMBINE PROCESSING OBJECT
CHAR CHAP_AUTO[] =    {$05,$f1,$03,$00,$01,$01}; //AUTOMIXER DEVICE IN LONDON ARCHITECTURE
CHAR BR_MIC_MIXER[] = {$05,$f1,$03,$00,$01,$06}; //MIXER 
CHAR MR_MIC_MIXER[] = {$05,$f1,$03,$00,$01,$07};//MIXER
CHAR VIDEO_SERVER[] = {$05,$f1,$03,$00,$01,$08};//ROUTER
CHAR MICS[] =         {$05,$f1,$03,$00,$01,$02};//MATRIX MIXER
CHAR WC_GAIN[] =      {$05,$f1,$03,$00,$01,$04}; //GAIN OBJECT
CHAR RED_ROOMGAIN[] = {$05,$f1,$03,$00,$01,$09}; //N-GAIN OBJECT
CHAR SYSTEM_MATRIX[] ={$05,$f1,$03,$00,$01,$0A}; //SOURCE_MATRIX
CHAR BRIEFING_ROOM[] ={$05,$f1,$03,$00,$01,$0B}; //SOURCE_SELECTOR


INTEGER GAIN_STEP_PER = 1; //GAIN STEP IF USING SET_GAIN_PERCENT
INTEGER MAX_RAMPGAIN_PER = 100; //THESE ARE VALUES USING SUBSCRIBE%
INTEGER MIN_RAMPGAIN_PER = 0;

INTEGER TL1 =1;//TIMELINE FOR FEEDBACK
INTEGER TL2 = 2;//TimeLine to make sure we are still connected and resubscribe if connection is lost.


(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE
LONG REPEAT_TIME[1];//TIMELINE
LONG CHECK_REPEAT_TIME[1]
VOLATILE INTEGER bUPDATE_OK[76];//BUTTON EVENTS ON TP_BARGRAPHS TO PREVENT FEEDBACK LOOP WHEN USING ACTIVE BARGRAPHS
VOLATILE INTEGER iRM1_GROUP, iRM2_GROUP, iRM3_GROUP, iRM4_GROUP;//VARS TO PREVENT OVER-SENDING OF DYNAMIC TP COMMANDS IN THE FEEDBACK ROUTINE

(* SAMPLE MATRIX ROUTING USED IN BUTTON_EVENT*)
INTEGER MATRIX_INPUT;
INTEGER MATRIX_OUTPUT;

(* SAMPLE PROGRAMMING CONTROLLING AUTOMIXER GAINS *)
INTEGER BUTTON2[10]; //PSEUDO FEEDBACK EXAMPLE FOR THOSE WHO DON'T CARE ABOUT TRUE FEEDBACK (OR DON'T WANT TO DEAL WITH IT)
INTEGER RAMP_GAIN_PER; //RAMP_GAIN IN PERCENT <0-100>
INTEGER MASTEROUT_VOL; //KEEP TRACK OF MASTEROUT VOLUME

INTEGER BARGRAPH; //LINKS BARGRAPH VALUE IN LEVEL_EVENT TO INC/DEC IN BUTTON_EVENT

(* SAMPLE USED IN DEFINE_PROGRAM FOR UPDATING VOLUME BAR GRAPHS *)
INTEGER VOLUME;
CHAR VOLUME_infoComm[4];
LONG intVOL;
INTEGER MYVOL;

(*SUBSCRIBING TO A METER USING SUBSCRIBE%. UPDATING TO BARGRAPH IN DEFINE_PROGRAM *)
CHAR METER_FB[4];
INTEGER METER_FB_infocomm;
LONG intMETER_FB;
INTEGER myMETER;

INTEGER runOnce;

INTEGER GAIN_BARGRAPH;

INTEGER MMIX[8][8];
INTEGER MMIX_IN;
INTEGER MMIX_OUT;
INTEGER MMIX_FB;
INTEGER MMIX_VOL[8];

INTEGER MROUT[4][4];
INTEGER SMAT[8][8];
INTEGER SMAT_IN;
INTEGER SMAT_OUT;
INTEGER SMAT_FB;

INTEGER menuOUTPUTCARD;
INTEGER updatePhoneNumber;


INTEGER resubscribe = 0;
INTEGER SUBSCRIBED = 0;

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

#INCLUDE 'BSS_Soundweb_London.axi'

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_FUNCTION SUBSCRIBE_ALL()
{

	LOCAL_VAR INTEGER i;
	LOCAL_VAR INTEGER j;
	subscribed = 1;
	//SEE HELP FILE FOR COMPLETE DESCRIPTION OF FB[][] AND ON HOW THE SUBSCRIBE WORKS
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,MUTE) //FB[1] -- THIS IS THE VALUE YOU USE IN DEFINE_PROGRAM FOR FEEDBACK
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,MUTE) //FB[2]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,MUTE) //FB[3]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,MUTE) //FB[4]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,1,MUTE) //FB[5]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,3,MUTE) //FB[6]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,1,GROUP) //FB[7]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,2,GROUP) //FB[8]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,3,GROUP) //FB[9]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,4,GROUP) //FB[10]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,1,AUX) //FB[11]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,2,AUX) //FB[12]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,3,AUX) //FB[13]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,0,4,AUX) //FB[14]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,SOLO) //FB[15]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,SOLO)//FB[16]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,SOLO)//FB[17]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,SOLO)//FB[18]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,AUTO)//FB[19]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,AUTO)

	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,SOURCE_MUTE)//FB[21][12]
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,SOURCE_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,SOURCE_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,SOURCE_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,1,MASTER_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,2,MASTER_MUTE)//FB[30][12]
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,3,MASTER_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,4,MASTER_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,BGM_SELECT)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,BGM_SELECT)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,BGM_SELECT)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,BGM_SELECT)//FB[36][12]

	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,1,0,SOURCE_GAIN)//FB[37][10] SUBSCRIBE %'S ALWAYS HELD IN COLUMN 10
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,2,0,SOURCE_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,3,0,SOURCE_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,4,0,SOURCE_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,1,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,2,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,3,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,4,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,1,MASTER_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,2,MASTER_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,3,MASTER_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,4,MASTER_GAIN)//FB[48][10]

	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,PARTITION)//FB[49][12]	//PARITION #1
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,PARTITION)//FB[50][12]	//PARITION #2
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,PARTITION)//FB[51][12]	//PARITION #3
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,PARTITION)//FB[52][12]	//PARITION #4

	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,GROUP)//FB[53][12] //ROOM #1 GROUP
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,GROUP)//FB[54][12] //ROOM #2 GROUP
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,GROUP)//FB[55][12] //ROOM #3 GROUP
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,GROUP)//FB[56][12] //ROOM #4 GROUP
	
	// subscribe to telephone hybrid
	FOR(i = 1;i<=4;i++) // FB[57] - FB[60] is used for the main telephone number
	{
	    CALL 'SUBSCRIBE'(IO_CARD2,TELEPHONE,i,0,TELEPHONE_NUMBER)//Main number
	}
	CALL 'SUBSCRIBE'(IO_CARD2,TELEPHONE,0,0,TX_MUTE)//FB[61]
	CALL 'SUBSCRIBE'(IO_CARD2,TELEPHONE,0,0,RX_MUTE)//FB[62]
	CALL 'SUBSCRIBE'(IO_CARD2,TELEPHONE,0,0,INCOMING_CALL)//FB[63]
	CALL 'SUBSCRIBE'(IO_CARD2,TELEPHONE,0,0,AUTO_ANSWER)//FB[64]
	CALL 'SUBSCRIBE'(IO_CARD2,TELEPHONE,0,0,DIAL_HANGUP)//FB[65]
	
	CALL 'SUBSCRIBE%'(IO_CARD2,TELEPHONE,0,0,TX_GAIN)//FB[66]
	CALL 'SUBSCRIBE%'(IO_CARD2,TELEPHONE,0,0,RX_GAIN)//FB[67]
	CALL 'SUBSCRIBE%'(IO_CARD2,TELEPHONE,0,0,DTMF_GAIN)//FB[68]
	CALL 'SUBSCRIBE%'(IO_CARD2,TELEPHONE,0,0,DIAL_TONE_GAIN)//FB[69]
	CALL 'SUBSCRIBE%'(IO_CARD2,TELEPHONE,0,0,RING_GAIN)//FB[70]

	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,AUTO)//FB[71]
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,AUTO)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,1,0,OVERRIDE)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,2,0,OVERRIDE)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,3,0,OVERRIDE)
	CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,4,0,OVERRIDE)
	    
	FOR(I=1;I<=8;I++)//FB[77] -> FB[140] MATRIX_MIXER
	{
	    FOR(J=1;J<=8;J++)
	    {
		CALL 'SUBSCRIBE'(MICS,MM,J,I,ROUTE)
	    }
	}
	
	FOR(I=1;I<=4;I++) //FB[141-156] MATRIX ROUTER
	{
	    FOR(J=1;J<=4;J++)
	    {
		CALL 'SUBSCRIBE'(VIDEO_SERVER,ROUTER,J,I,ROUTE) 
	    }
	}
	
	FOR(I=1;I<=4;I++) //FB[157-172] AUTOMIXER GROUP INPUTS
	{
	    FOR(J=1;J<=4;J++)
	    {
		CALL 'SUBSCRIBE'(CHAP_AUTO,AUTOMIXER,I,J,GROUP) 
	    }
	}
	
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,1,0,GAIN)//FB[173]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,2,0,GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,3,0,GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,4,0,GAIN)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,1,0,MUTE)//FB[177] 
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,2,0,MUTE)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,3,0,MUTE)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,4,0,MUTE)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,1,0,SOLO)//FB[181]
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,2,0,SOLO)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,3,0,SOLO)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,4,0,SOLO)
	CALL 'SUBSCRIBE'(MR_MIC_MIXER,MIXER,0,1,MUTE)//FB[185]
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,PHANTOM)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,2,0,PHANTOM)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,3,0,PHANTOM)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,4,0,PHANTOM)//FB[189]
	CALL 'SUBSCRIBE'(WC_GAIN,GAIN,1,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,1,0,MUTE)//FB[191]
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,2,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,3,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,4,0,MUTE)
	CALL 'SUBSCRIBE'(RED_ROOMGAIN,N_GAIN,0,1,MUTE)
	CALL 'SUBSCRIBE'(BRIEFING_ROOM,SOURCE_SELECTOR,0,0,0)//FB[196]
	
	FOR(J=1;J<=8;J++)//FB[197-204]
	{
	    CALL 'SUBSCRIBE'(SYSTEM_MATRIX,SOURCE_MATRIX,J,0,ROUTE)
	}
	
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,1,0,METER) //FB[205]--[208] ARE PLACE HOLDERS IN FB ARRAY.
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,2,0,METER) //FB[206]   	SUBSCRIBES ARE CALLED IN BUTTON_EVENT 10
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,3,0,METER) //FB[207]
	CALL 'UN_SUBSCRIBE%'(IO_CARD1,OUTPUT_CARD,4,0,METER) //FB[208]
	CALL 'SUBSCRIBE%'(WC_GAIN,GAIN,1,0,GAIN)
	
	//subscribing to gains
	CALL 'SUBSCRIBE%'(mics,mm,1,1,GAIN)//FB[210] matrix mixer
	CALL 'SUBSCRIBE%'(mics,mm,1,2,GAIN)
	CALL 'SUBSCRIBE%'(mics,mm,1,3,GAIN)
	CALL 'SUBSCRIBE%'(mics,mm,1,4,GAIN)
	CALL 'SUBSCRIBE%'(mics,mm,1,5,GAIN)
	CALL 'SUBSCRIBE%'(mics,mm,1,6,GAIN)
	CALL 'SUBSCRIBE%'(mics,mm,1,7,GAIN)
	CALL 'SUBSCRIBE%'(mics,mm,1,8,GAIN)
	
	//automixer
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,1,GAIN)//FB[218]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,3,GAIN)
	
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,1,0,PAN)//FB[220]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,2,0,PAN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,3,0,PAN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,4,0,PAN)
	
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,1,0,OFF_GAIN)//FB[224]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,2,0,OFF_GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,3,0,OFF_GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,4,0,OFF_GAIN)
	
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,1,AUX_GAIN)//FB[228]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,2,AUX_GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,3,AUX_GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,4,AUX_GAIN)
	
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,1,GROUP_GAIN)//FB[232]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,2,GROUP_GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,3,GROUP_GAIN)
	CALL 'SUBSCRIBE%'(CHAP_AUTO,AUTOMIXER,0,4,GROUP_GAIN)
	
	//mixer gains
	CALL 'SUBSCRIBE%'(MR_MIC_MIXER,MIXER,1,0,GAIN)//FB[236]
	CALL 'SUBSCRIBE%'(MR_MIC_MIXER,MIXER,2,0,GAIN)
	CALL 'SUBSCRIBE%'(MR_MIC_MIXER,MIXER,3,0,GAIN)
	CALL 'SUBSCRIBE%'(MR_MIC_MIXER,MIXER,4,0,GAIN)
	
	CALL 'SUBSCRIBE%'(MR_MIC_MIXER,MIXER,0,1,GAIN)//FB[240]
	
	// INPUT_CARD gains
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,GAIN)//FB[241]
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,2,0,GAIN)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,3,0,GAIN)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,4,0,GAIN)
	
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,ATTACK)//FB[245]
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,2,0,ATTACK)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,3,0,ATTACK)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,4,0,ATTACK)
	
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,RELEASED)//FB[249]
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,2,0,RELEASED)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,3,0,RELEASED)
	CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,4,0,RELEASED)
	
	//NGAIN gains
	CALL 'SUBSCRIBE%'(RED_ROOMGAIN,N_GAIN,1,0,GAIN)//FB[253]
	CALL 'SUBSCRIBE%'(RED_ROOMGAIN,N_GAIN,2,0,GAIN)
	CALL 'SUBSCRIBE%'(RED_ROOMGAIN,N_GAIN,3,0,GAIN)
	CALL 'SUBSCRIBE%'(RED_ROOMGAIN,N_GAIN,4,0,GAIN)
	
	CALL 'SUBSCRIBE%'(RED_ROOMGAIN,N_GAIN,0,1,GAIN)//FB[257]
	
	//OUTPUTCARD
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,ATTACK)//FB[258]
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,2,0,ATTACK)
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,3,0,ATTACK)
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,4,0,ATTACK)  

	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,RELEASED)//FB[262]
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,2,0,RELEASED)
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,3,0,RELEASED)
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,4,0,RELEASED)
	
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,REFERENCE)//FB[266]
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,2,0,REFERENCE)
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,3,0,REFERENCE)
	CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,4,0,REFERENCE)
	    
	//SUBSCRIBING TO METERS CAUSES A LOT OF SERIAL TRAFFIC, USE WITH CARE
	//CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,METER)

	updatePhoneNumber = 1; // to make sure the phonenumber is up to date after subscribing.
}
DEFINE_START

REPEAT_TIME[1] = 300; //300ms TO UPDATE FEEDBACK
CHECK_REPEAT_TIME[1] = 5000; //check to see if we are connected every 5 seconds
TIMELINE_CREATE(TL1, REPEAT_TIME, 1, TIMELINE_ABSOLUTE,TIMELINE_REPEAT)//FEEDBACK TIMELINE;
TIMELINE_CREATE(TL2,CHECK_REPEAT_TIME, 1,TIMELINE_ABSOLUTE,TIMELINE_REPEAT)//Resubscribe timeline. 
iRM1_GROUP = 99; //SET TO SOME BOGUS VALUE TO ENSURE FIRST PASS IN FEEDBACK IS UPDATED CORRECTLY
iRM2_GROUP = 99;
iRM3_GROUP = 99;
iRM4_GROUP = 99;
runOnce = 1
SMAT_OUT = 1;
MMIX_OUT = 1;


(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT [dvSOUNDWEB]
{
    ONLINE:
    {	
	STARTUP = 1; //BEGIN LOGGING FEEDBACK VARIABLES:  THESE ARE THE ONLY VARIABLES 	
		    //THAT WILL BE COMPARED TO RECEIVED STRINGS FOR TRUE FEEDBACK
	T = 0; //initialization
      
	SUBSCRIBE_ALL();
      
      
	STARTUP = 0; //END LOGGING FEEDBACK VARIABLES


    }
}//DATA_EVENT
LEVEL_EVENT[dvTP,1] //CONTROLLING GAIN USING AN ACTIVE LEVEL ON TP *Without* TRUE FEEDBACK
{
LOCAL_VAR FLOAT VOL;
LOCAL_VAR INTEGER PERCENT;
LOCAL_VAR INTEGER MODI;
 
    BARGRAPH = LEVEL.VALUE; //UPDATE GLOBAL VAR IN INCREMENT/DECREMENT BUTTON_EVENT 11,12
    //IF USING BARGRAPH ON AMX TP WITH RANGE 0-255
    //VOL = (BARGRAPH * .39); //SCALE 0-255 BARGRAPH TO 0-100% 
    //PERCENT = TYPE_CAST(VOL);
    //CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,1,0,Percent)

    //IF USING BARGRAPH ON AMX TP WITH RANGE 0-100
    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,1,0,LEVEL.VALUE)
    //SEND_COMMAND dvTP, "'TEXT1 -',ITOA(LEVEL.VALUE),'%'"; //SEND TEST TO TP

}
LEVEL_EVENT[dvTP,2]//GAIN USING ACTIVE LEVEL *With* FEEDBACK FROM LONDON
LEVEL_EVENT[dvTP,3]//ROOM_COMBINE RM1-4 SOURCE_GAIN 
LEVEL_EVENT[dvTP,4]
LEVEL_EVENT[dvTP,5]
LEVEL_EVENT[dvTP,6]//ROOM_COMBINE RM1-4 BGM_GAIN
LEVEL_EVENT[dvTP,7]
LEVEL_EVENT[dvTP,8]
LEVEL_EVENT[dvTP,9]
LEVEL_EVENT[dvTP,10]//ROOM_COMBINE RM1-4 MASTER_GAIN
LEVEL_EVENT[dvTP,11]
LEVEL_EVENT[dvTP,12]
LEVEL_EVENT[dvTP,13]
{

SELECT  //THIS SELECT STATEMENT IS TO PREVENT A FEEDBACK LOOP WHEN USING ACTIVE BARGRAPHS *With* TRUE FEEDBACK
{
    ACTIVE (LEVEL.INPUT.LEVEL = 2)://ROOM1 SOURCE_GAIN 	
    {
	IF(bUPDATE_OK[1])//BUTTON_EVENT ASSOCIATED WITH ACTIVE BARGRAPH
	    CALL 'SET_ROOMCOMBINE'(HALL_A,1,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 3)://ROOM2 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[2])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,2,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 4)://ROOM3 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[3])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,3,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 5)://ROOM4 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[4])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,4,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 6)://ROOM1 BGM_GAIN	
    {
	IF(bUPDATE_OK[5])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,1,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 7):///ROOM2 BGM_GAIN	
    {
	IF(bUPDATE_OK[6])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,2,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 8)://ROOM3 BGM_GAIN	
    {
	IF(bUPDATE_OK[7])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,3,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 9)://ROOM4 BGM_GAIN	
    {
	IF(bUPDATE_OK[8])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,4,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 10):	
    {
	IF(bUPDATE_OK[9])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,1,MASTER_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL =11):	
    {
	IF(bUPDATE_OK[10])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,2,MASTER_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL =12):	
    {
	IF(bUPDATE_OK[11])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,3,MASTER_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL =13):	
    {
	IF(bUPDATE_OK[12])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,4,MASTER_GAIN,LEVEL.VALUE)
    }
}
(*
    IF(bUPDATE_OK)//BARGRAPH BUTTON FEEDBACK TO PREVENT FEEDBACK LOOP WHEN USING ACTIVE BARGRAPHS (SHORTER METHOD)
    {
	IF(LEVEL.INPUT.LEVEL <=5)//SOURCE_GAIN
	    CALL 'SET_ROOMCOMBINE'(HALL_A,(LEVEL.INPUT.LEVEL-1),0,SOURCE_GAIN,LEVEL.VALUE)
	ELSE IF((LEVEL.INPUT.LEVEL >=6)&&(LEVEL.INPUT.LEVEL <=9))//BGM_GAIN
	    CALL 'SET_ROOMCOMBINE'(HALL_A,(LEVEL.INPUT.LEVEL-5),0,BGM_GAIN,LEVEL.VALUE)
	ELSE IF(LEVEL.INPUT.LEVEL >=10)//MASTER_GAIN
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,(LEVEL.INPUT.LEVEL-9),MASTER_GAIN,LEVEL.VALUE)
    }
*)
}
LEVEL_EVENT[dvTP,14]
LEVEL_EVENT[dvTP,15]
LEVEL_EVENT[dvTP,16]
LEVEL_EVENT[dvTP,17]
LEVEL_EVENT[dvTP,18]
{

SELECT  //THIS SELECT STATEMENT IS TO PREVENT A FEEDBACK LOOP WHEN USING ACTIVE BARGRAPHS *With* TRUE FEEDBACK
{
    ACTIVE (LEVEL.INPUT.LEVEL = 14)://ROOM1 SOURCE_GAIN 	
    {
	IF(bUPDATE_OK[13])//BUTTON_EVENT ASSOCIATED WITH ACTIVE BARGRAPH
	    CALL 'SET_TELEPHONE'(IO_CARD2,0,0,TX_GAIN,LEVEL.VALUE);
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 15)://ROOM2 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[14])
	    CALL 'SET_TELEPHONE'(IO_CARD2,0,0,RX_GAIN,LEVEL.VALUE);
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 16)://ROOM3 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[15])
	    CALL 'SET_TELEPHONE'(IO_CARD2,0,0,DTMF_GAIN,LEVEL.VALUE);
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 17)://ROOM4 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[16])
	    CALL 'SET_TELEPHONE'(IO_CARD2,0,0,DIAL_TONE_GAIN,LEVEL.VALUE);
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 18)://ROOM1 BGM_GAIN	
    {
	IF(bUPDATE_OK[17])
	    CALL 'SET_TELEPHONE'(IO_CARD2,0,0,RING_GAIN,LEVEL.VALUE);
    }
}
}
LEVEL_EVENT[dvTP,19]//MATRIX MIXER
{
    IF(bUPDATE_OK[18])
	CALL 'SET_GAIN%'(MICS,MM,1,MMIX_OUT,LEVEL.VALUE);
}
LEVEL_EVENT[dvTP,20]//AUTOMIXER GAINS
LEVEL_EVENT[dvTP,21]
LEVEL_EVENT[dvTP,22]
LEVEL_EVENT[dvTP,23]
LEVEL_EVENT[dvTP,24]
LEVEL_EVENT[dvTP,25]
LEVEL_EVENT[dvTP,26]
LEVEL_EVENT[dvTP,27]
LEVEL_EVENT[dvTP,28]
LEVEL_EVENT[dvTP,29]
LEVEL_EVENT[dvTP,30]
LEVEL_EVENT[dvTP,31]
LEVEL_EVENT[dvTP,32]
LEVEL_EVENT[dvTP,33]
LEVEL_EVENT[dvTP,34]
LEVEL_EVENT[dvTP,35]
LEVEL_EVENT[dvTP,36]
LEVEL_EVENT[dvTP,37]
LEVEL_EVENT[dvTP,38]
LEVEL_EVENT[dvTP,39]
LEVEL_EVENT[dvTP,40]
LEVEL_EVENT[dvTP,41]
{
SELECT
{
    ACTIVE(LEVEL.INPUT.LEVEL = 20):
    {
	IF(bUPDATE_OK[19])
	    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,1,0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL == 21):
    {
	IF(bUPDATE_OK[20])
	    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,2,0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 22):
    {
	IF(bUPDATE_OK[21])
	    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,3,0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 23):
    {
	IF(bUPDATE_OK[22])
	    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,4,0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 24):
    {
	IF(bUPDATE_OK[23])
	    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,0,(LEVEL.INPUT.LEVEL-23),LEVEL.VALUE)//LEFT
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 25):
    {
	IF(bUPDATE_OK[24])
	    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,0,(LEVEL.INPUT.LEVEL-22),LEVEL.VALUE)//RIGHT
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 26):
    {
	IF(bUPDATE_OK[25])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-25),0,PAN,LEVEL.VALUE)//PAN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 27):
    {
	IF(bUPDATE_OK[26])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-25),0,PAN,LEVEL.VALUE)//PAN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 28):
    {
	IF(bUPDATE_OK[27])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-25),0,PAN,LEVEL.VALUE)//PAN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 29):
    {
	IF(bUPDATE_OK[28])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-25),0,PAN,LEVEL.VALUE)//PAN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 30):
    {
	IF(bUPDATE_OK[29])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-29),0,OFF_GAIN,LEVEL.VALUE)//OFF_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 31):
    {
	IF(bUPDATE_OK[30])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-29),0,OFF_GAIN,LEVEL.VALUE)//OFF_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 32):
    {
	IF(bUPDATE_OK[31])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-29),0,OFF_GAIN,LEVEL.VALUE)//OFF_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 33):
    {
	IF(bUPDATE_OK[32])
	    CALL 'SET_MIXER'(CHAP_AUTO,(LEVEL.INPUT.LEVEL-29),0,OFF_GAIN,LEVEL.VALUE)//OFF_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 34):
    {
	IF(bUPDATE_OK[33])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-33),AUX_GAIN,LEVEL.VALUE)//AUX_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 35):
    {
	IF(bUPDATE_OK[34])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-33),AUX_GAIN,LEVEL.VALUE)//AUX_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 36):
    {
	IF(bUPDATE_OK[35])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-33),AUX_GAIN,LEVEL.VALUE)//AUX_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 37):
    {
	IF(bUPDATE_OK[36])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-33),AUX_GAIN,LEVEL.VALUE)//AUX_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 38):
    {
	IF(bUPDATE_OK[37])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-37),GROUP_GAIN,LEVEL.VALUE)//GROUP_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 39):
    {
	IF(bUPDATE_OK[38])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-37),GROUP_GAIN,LEVEL.VALUE)//GROUP_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 40):
    {
	IF(bUPDATE_OK[39])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-37),GROUP_GAIN,LEVEL.VALUE)//GROUP_GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 41):
    {
	IF(bUPDATE_OK[40])
	    CALL 'SET_MIXER'(CHAP_AUTO,0,(LEVEL.INPUT.LEVEL-37),GROUP_GAIN,LEVEL.VALUE)//GROUP_GAIN
    }
}
	
}

LEVEL_EVENT[dvTP,42]//MIXER GAINS
LEVEL_EVENT[dvTP,43]
LEVEL_EVENT[dvTP,44]
LEVEL_EVENT[dvTP,45]
LEVEL_EVENT[dvTP,46]
{

select
{
    ACTIVE(LEVEL.INPUT.LEVEL = 42):
    {
	IF(bUPDATE_OK[41])
	    CALL 'SET_GAIN%'(MR_MIC_MIXER,MIXER,(LEVEL.INPUT.LEVEL-41),0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 43):
    {
	IF(bUPDATE_OK[42])
	    CALL 'SET_GAIN%'(MR_MIC_MIXER,MIXER,(LEVEL.INPUT.LEVEL-41),0,LEVEL.VALUE)//INPUTS
	    }
    ACTIVE(LEVEL.INPUT.LEVEL = 44):
    {
	IF(bUPDATE_OK[43])
	    CALL 'SET_GAIN%'(MR_MIC_MIXER,MIXER,(LEVEL.INPUT.LEVEL-41),0,LEVEL.VALUE)//INPUTS
	    }
    ACTIVE(LEVEL.INPUT.LEVEL = 45):
    {
	IF(bUPDATE_OK[44])
	    CALL 'SET_GAIN%'(MR_MIC_MIXER,MIXER,(LEVEL.INPUT.LEVEL-41),0,LEVEL.VALUE)//INPUTS
	    }
    ACTIVE(LEVEL.INPUT.LEVEL = 46):
    {
	IF(bUPDATE_OK[45])
	    CALL 'SET_GAIN%'(MR_MIC_MIXER,MIXER,0,(LEVEL.INPUT.LEVEL-45),LEVEL.VALUE)//LEFT OUT
    }

}
}

LEVEL_EVENT[dvTP,47]//INPUT_CARD
LEVEL_EVENT[dvTP,48]
LEVEL_EVENT[dvTP,49]
LEVEL_EVENT[dvTP,50]
LEVEL_EVENT[dvTP,51]
LEVEL_EVENT[dvTP,52]
LEVEL_EVENT[dvTP,53]
LEVEL_EVENT[dvTP,54]
LEVEL_EVENT[dvTP,55]
LEVEL_EVENT[dvTP,56]
LEVEL_EVENT[dvTP,57]
LEVEL_EVENT[dvTP,58]
{

SELECT
{
    ACTIVE(LEVEL.INPUT.LEVEL = 47):
    {
	IF(bUPDATE_OK[46])
	    CALL 'SET_GAIN%'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-46),0,LEVEL.VALUE)//GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 48):
    {
	IF(bUPDATE_OK[47])
	    CALL 'SET_GAIN%'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-46),0,LEVEL.VALUE)//GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 49):
    {
	IF(bUPDATE_OK[48])
	    CALL 'SET_GAIN%'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-46),0,LEVEL.VALUE)//GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 50):
    {
	IF(bUPDATE_OK[49])
	    CALL 'SET_GAIN%'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-46),0,LEVEL.VALUE)//GAIN
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 51):
    {
	IF(bUPDATE_OK[50])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-50),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 52):
    {
	IF(bUPDATE_OK[51])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-50),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 53):
    {
	IF(bUPDATE_OK[52])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-50),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 54):
    {
	IF(bUPDATE_OK[53])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-50),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 55):
    {
	IF(bUPDATE_OK[54])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-54),0,RELEASED,LEVEL.VALUE)//RELEASED
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 56):
    {
	IF(bUPDATE_OK[55])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-54),0,RELEASED,LEVEL.VALUE)//RELEASED
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 57):
    {
	IF(bUPDATE_OK[56])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-54),0,RELEASED,LEVEL.VALUE)//RELEASED
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 58):
    {
	IF(bUPDATE_OK[57])
	    CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,(LEVEL.INPUT.LEVEL-54),0,RELEASED,LEVEL.VALUE)//RELEASED
    }
}
	
}
LEVEL_EVENT[dvTP,59]//NGAIN
LEVEL_EVENT[dvTP,60]
LEVEL_EVENT[dvTP,61]
LEVEL_EVENT[dvTP,62]
LEVEL_EVENT[dvTP,63]
{
SELECT
{
    ACTIVE(LEVEL.INPUT.LEVEL = 59):
    {
	IF(bUPDATE_OK[58])
	    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,(LEVEL.INPUT.LEVEL-58),0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 60):
    {
	IF(bUPDATE_OK[59])
	    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,(LEVEL.INPUT.LEVEL-58),0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 61):
    {
	IF(bUPDATE_OK[60])
	    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,(LEVEL.INPUT.LEVEL-58),0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 62):
    {
	IF(bUPDATE_OK[61])
	    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,(LEVEL.INPUT.LEVEL-58),0,LEVEL.VALUE)//INPUTS
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 63):
    {
	IF(bUPDATE_OK[62])
	    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,0,(LEVEL.INPUT.LEVEL-62),LEVEL.VALUE)//OUT
    }
}
}
LEVEL_EVENT[dvTP,64]//OUTPUT_CARD
LEVEL_EVENT[dvTP,65]
LEVEL_EVENT[dvTP,66]
LEVEL_EVENT[dvTP,67]
LEVEL_EVENT[dvTP,68]
LEVEL_EVENT[dvTP,69]
LEVEL_EVENT[dvTP,70]
LEVEL_EVENT[dvTP,71]
LEVEL_EVENT[dvTP,72]
LEVEL_EVENT[dvTP,73]
LEVEL_EVENT[dvTP,74]
LEVEL_EVENT[dvTP,75]
{
SELECT
{
    ACTIVE(LEVEL.INPUT.LEVEL = 64):
    {
	IF(bUPDATE_OK[63])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-63),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 65):
    {
	IF(bUPDATE_OK[64])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-63),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 66):
    {
	IF(bUPDATE_OK[65])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-63),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 67):
    {
	IF(bUPDATE_OK[66])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-63),0,ATTACK,LEVEL.VALUE)//ATTACK
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 68):
    {
	IF(bUPDATE_OK[67])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-67),0,RELEASED,LEVEL.VALUE)//RELEASE
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 69):
    {
	IF(bUPDATE_OK[68])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-67),0,RELEASED,LEVEL.VALUE)//RELEASE
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 70):
    {
	IF(bUPDATE_OK[69])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-67),0,RELEASED,LEVEL.VALUE)//RELEASE
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 71):
    {
	IF(bUPDATE_OK[70])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-67),0,RELEASED,LEVEL.VALUE)//RELEASE
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 72):
    {
	IF(bUPDATE_OK[71])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-71),0,REFERENCE,LEVEL.VALUE)//REFERENCE
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 73):
    {
	IF(bUPDATE_OK[72])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-71),0,REFERENCE,LEVEL.VALUE)//REFERENCE
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 74):
    {
	IF(bUPDATE_OK[73])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-71),0,REFERENCE,LEVEL.VALUE)//REFERENCE
    }
    ACTIVE(LEVEL.INPUT.LEVEL = 75):
    {
	IF(bUPDATE_OK[74])
	    CALL 'SET_VAL'(IO_CARD4,OUTPUT_CARD,(LEVEL.INPUT.LEVEL-71),0,REFERENCE,LEVEL.VALUE)//REFERENCE
    }
}
}
(*
LEVEL_EVENT[dvTP,76] //GAIN FB[209] 
{
LOCAL_VAR FLOAT VOL;
LOCAL_VAR INTEGER PERCENT; 
LOCAL_VAR INTEGER MODI;
LOCAL_VAR CHAR MY_LEVEL;
    

    IF (FB[209][10] <> LEVEL.VALUE)
    {
	FB[209][10] = LEVEL.VALUE; //FB[209] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,LEVEL.VALUE)
	//SEND_COMMAND dvTP, "'TEXT1 -',ITOA(PERCENT),'%'"; //SEND TEXT TO TP
    }

}
*)
BUTTON_EVENT [dvTP,1] //MENU BUTTONS
BUTTON_EVENT [dvTP,2]
BUTTON_EVENT [dvTP,3]
BUTTON_EVENT [dvTP,4]
BUTTON_EVENT [dvTP,5]
BUTTON_EVENT [dvTP,6]
BUTTON_EVENT [dvTP,7]
BUTTON_EVENT [dvTP,8]
BUTTON_EVENT [dvTP,9]
{
PUSH: 
    {
(*    
    IF(menuOUTPUTCARD)
	{
	CALL 'UN_SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) 
	CALL 'UN_SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,2,0,METER) 
	//CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) 
	//CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) 
	menuOUTPUTCARD =0
	}
*)
    }

}

BUTTON_EVENT [dvTP,10]//MENU OUTPUT_CARD BUTTON
{
PUSH: 
    {
(*
    CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,1,0,METER) //FB[21]
    CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,2,0,METER) //FB[22]
    //CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,3,0,METER) //FB[23]
    //CALL 'SUBSCRIBE%'(IO_CARD4,OUTPUT_CARD,4,0,METER) //FB[24]
    menuOUTPUTCARD =1
*)
    }
}
BUTTON_EVENT [dvTP,15]//MATRIX MIXER SOURCE
BUTTON_EVENT [dvTP,16]
BUTTON_EVENT [dvTP,17]
BUTTON_EVENT [dvTP,18]
BUTTON_EVENT [dvTP,19]
BUTTON_EVENT [dvTP,20]
BUTTON_EVENT [dvTP,21]
BUTTON_EVENT [dvTP,22]
{
PUSH: 
    {
    LOCAL_VAR INTEGER FB_INDEX;
    
    FB_INDEX =((MMIX_OUT-1)*8)+((PUSH_CHANNEL-14)+76)
    IF(FB[FB_INDEX][12])//UNROUTE
	{
	CALL 'SET_VAL'(MICS,MM,(PUSH_CHANNEL-14),MMIX_OUT,MUTE,0)
	}
    ELSE //ROUTE
	{
	CALL 'SET_VAL'(MICS,MM,(PUSH_CHANNEL-14),MMIX_OUT,MUTE,1)
	}

    }
}

BUTTON_EVENT [dvTP,23]//MATRIX MIXER DESTINATION
BUTTON_EVENT [dvTP,24]
BUTTON_EVENT [dvTP,25]
BUTTON_EVENT [dvTP,26]
BUTTON_EVENT [dvTP,27]
BUTTON_EVENT [dvTP,28]
BUTTON_EVENT [dvTP,29]
BUTTON_EVENT [dvTP,30]
{
PUSH: 
    {
    MMIX_OUT = (PUSH_CHANNEL-22)
    //ON[dvTP,PUSH_CHANNEL]
    SEND_LEVEL DVTP,1,MMIX_VOL[MMIX_OUT];
    }
}


BUTTON_EVENT [dvTP,31]//MATRIX ROUTER
BUTTON_EVENT [dvTP,32]
BUTTON_EVENT [dvTP,33]
BUTTON_EVENT [dvTP,34]
BUTTON_EVENT [dvTP,35]
BUTTON_EVENT [dvTP,36]
BUTTON_EVENT [dvTP,37]
BUTTON_EVENT [dvTP,38]
BUTTON_EVENT [dvTP,39]
BUTTON_EVENT [dvTP,40]
BUTTON_EVENT [dvTP,41]
BUTTON_EVENT [dvTP,42]
BUTTON_EVENT [dvTP,43]
BUTTON_EVENT [dvTP,44]
BUTTON_EVENT [dvTP,45]
BUTTON_EVENT [dvTP,46]
{
PUSH:
    {
    IF((PUSH_CHANNEL-30)<=4)
	{
	IF(FB[(PUSH_CHANNEL+110)][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-30),1,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-30),1,ROUTE,1)
	}
    ELSE IF((PUSH_CHANNEL-30 >=5) && (PUSH_CHANNEL-30 <= 8))
	{
	IF(FB[(PUSH_CHANNEL+110)][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-34),2,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-34),2,ROUTE,1)
	}
    ELSE IF((PUSH_CHANNEL-30>= 9) && (PUSH_CHANNEL -30 <= 12))
	{
	IF(FB[PUSH_CHANNEL+110][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-38),3,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-38),3,ROUTE,1)
	}
    ELSE IF((PUSH_CHANNEL-30 >= 13) && (PUSH_CHANNEL-30 <=16))
	{
	IF(FB[PUSH_CHANNEL+110][12])
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-42),4,ROUTE,0)
	ELSE
	    CALL 'SET_VAL'(VIDEO_SERVER,ROUTER,(PUSH_CHANNEL-42),4,ROUTE,1)
	}
    }
}

(************************************** AUTOMIXER  *************************************************)
	
BUTTON_EVENT [dvTP,50]//AUTOMIXER INPUT MUTES
BUTTON_EVENT [dvTP,51]
BUTTON_EVENT [dvTP,52]
BUTTON_EVENT [dvTP,53]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-49][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-49,0,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-49,0,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,54]//SOLO
BUTTON_EVENT [dvTP,55]
BUTTON_EVENT [dvTP,56]
BUTTON_EVENT [dvTP,57]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-39][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-53,0,SOLO,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-53,0,SOLO,1) 
	}
    }
}
BUTTON_EVENT [dvTP,62]//AUTO
BUTTON_EVENT [dvTP,63]
BUTTON_EVENT [dvTP,64]
BUTTON_EVENT [dvTP,65]
{
PUSH:
    {
    
    IF(PUSH_CHANNEL == 62 || PUSH_CHANNEL == 63){
	IF(FB[PUSH_CHANNEL-43][12])
	    {
	    CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-61,0,AUTO,0) 
	    }
	ELSE
	    {
	    CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-61,0,AUTO,1) 
	    }
    }
    ELSE{
	IF(FB[PUSH_CHANNEL+7][12])
	    {
	    CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-61,0,AUTO,0) 
	    }
	ELSE
	    {
	    CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-61,0,AUTO,1) 
	    }
    }
    }
}
BUTTON_EVENT [dvTP,66]//OVERRIDE
BUTTON_EVENT [dvTP,67]
BUTTON_EVENT [dvTP,68]
BUTTON_EVENT [dvTP,69]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+7][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-65,0,OVERRIDE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL-65,0,OVERRIDE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,70]//GROUP INPUT 1
BUTTON_EVENT [dvTP,71]
BUTTON_EVENT [dvTP,72]
BUTTON_EVENT [dvTP,73]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+87][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,1,PUSH_CHANNEL-69,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,1,PUSH_CHANNEL-69,GROUP,1) 
	}
    }
}
BUTTON_EVENT [dvTP,74]//GROUP INPUT 2
BUTTON_EVENT [dvTP,75]
BUTTON_EVENT [dvTP,76]
BUTTON_EVENT [dvTP,77]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+87][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,2,PUSH_CHANNEL-73,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,2,PUSH_CHANNEL-73,GROUP,1) 
	}
    }
}
BUTTON_EVENT [dvTP,78]//GROUP INPUT 3
BUTTON_EVENT [dvTP,79]
BUTTON_EVENT [dvTP,80]
BUTTON_EVENT [dvTP,81]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+87][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,3,PUSH_CHANNEL-77,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,3,PUSH_CHANNEL-77,GROUP,1) 
	}
    }
}
BUTTON_EVENT [dvTP,82]//GROUP INPUT 4
BUTTON_EVENT [dvTP,83]
BUTTON_EVENT [dvTP,84]
BUTTON_EVENT [dvTP,85]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL+87][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,4,PUSH_CHANNEL-81,GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,4,PUSH_CHANNEL-81,GROUP,1) 
	}
    }
}
BUTTON_EVENT[dvTP,86]
{
PUSH:
    {
    IF(FB[5][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,MUTE,1) 
	}
    }
}
BUTTON_EVENT[dvTP,87]
{
PUSH:
    {
    IF(FB[6][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,3,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,3,MUTE,1) 
	}
    }
}
BUTTON_EVENT[dvTP,88] //MASTER GROUP OUTPUTE MUTES
BUTTON_EVENT[dvTP,89]
BUTTON_EVENT[dvTP,90]
BUTTON_EVENT[dvTP,91]
{
PUSH:
    {
    IF(FB[PUSH_CHANNEL-81][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-87),GROUP,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-87),GROUP,1) 
	}
    }
}
BUTTON_EVENT[dvTP,92] //MASTER AUX OUTPUT MUTES
BUTTON_EVENT[dvTP,93]
BUTTON_EVENT[dvTP,94]
BUTTON_EVENT[dvTP,95]
{
PUSH:
    {
    IF(FB[PUSH_CHANNEL-81][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-91),AUX,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,(PUSH_CHANNEL-91),AUX,1) 
	}
    }
}
/*{
PUSH:
    {
    CALL 'SET_MIXER'(CHAP_AUTO,1,0,OVERRIDE,1)//ON CHANNEL 1 OVERRIDE;OUPUT FIELD MUST BE ZERO TO CONTROL AN INPUT FUNCTION 
    CALL 'SET_MIXER'(CHAP_AUTO,2,0,OVERRIDE,0)//OFF CHANNEL 2 OVERRIDE
    CALL 'SET_MIXER'(CHAP_AUTO,3,0,OVERRIDE,1)//ON CHANNEL 3 OVERRIDE
    CALL 'SET_MIXER'(CHAP_AUTO,3,0,AUTO,1)//OFF CHANNEL 3 AUTO
    CALL 'SET_MIXER'(CHAP_AUTO,1,0,OVERRIDE,0)//OFF CHANNEL 1 OVERRIDE
    
    }
}*/

(***********************************************************************************************************)
(********************************************   ROOM COMBINE    ********************************************)
(***********************************************************************************************************)
//ALL ROOM COMBINE CODE IS TRUE FEEDBACK
BUTTON_EVENT [dvTP,100]//ROOM_COMBINE SOURCE MUTE ROOM 1-4
BUTTON_EVENT [dvTP,101]
BUTTON_EVENT [dvTP,102]
BUTTON_EVENT [dvTP,103]
{
PUSH:
    {

	IF(FB[PUSH_CHANNEL-79][12])//FB[21], FB[22], FB[23], FB[24] IN DATA_EVENT:ONLINE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-99,0,SOURCE_MUTE,0)//UNMUTE
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-99,0,SOURCE_MUTE,1)//MUTE

    }
}
BUTTON_EVENT [dvTP,104]//ROOM_COMBINE BGM MUTE ROOM 1-4
BUTTON_EVENT [dvTP,105]
BUTTON_EVENT [dvTP,106]
BUTTON_EVENT [dvTP,107]
{
PUSH:
    {
	IF(FB[PUSH_CHANNEL-79][12])//FB[25-28]
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-103,0,BGM_MUTE,0)//UNMUTE
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-103,0,BGM_MUTE,1)//MUTE
    }
}

BUTTON_EVENT [dvTP,108]//ROOM_COMBINE MASTER_MUTE ROOM 1-4
BUTTON_EVENT [dvTP,109]
BUTTON_EVENT [dvTP,110]
BUTTON_EVENT [dvTP,111]
{
PUSH:
    {
	IF(FB[PUSH_CHANNEL-79][12])//FB[29-32]
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,PUSH_CHANNEL-107,MASTER_MUTE,0)//UNMUTE
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,PUSH_CHANNEL-107,MASTER_MUTE,1)//MUTE
    }
}

BUTTON_EVENT [dvTP,112]//ROOM_COMBINE BGM_SELECT INPUT 1
BUTTON_EVENT [dvTP,113]
BUTTON_EVENT [dvTP,114]
BUTTON_EVENT [dvTP,115]
{
PUSH:
    {
	//CALL 'SET_ROOMCOMBINE'(HALL_A,1,0,BGM_SELECT,0)//ROOM 1 NO SOURCE
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-111,0,BGM_SELECT,1)//ROOM 1 INPUT 1
    }
}
BUTTON_EVENT [dvTP,116]//ROOM_COMBINE BGM_SELECT INPUT 2
BUTTON_EVENT [dvTP,117]
BUTTON_EVENT [dvTP,118]
BUTTON_EVENT [dvTP,119]
{
PUSH:
    {
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-115,0,BGM_SELECT,2)//ROOM 1 INPUT 2
    }
}
BUTTON_EVENT [dvTP,120]//ROOM_COMBINE BGM_SELECT INPUT 3
BUTTON_EVENT [dvTP,121]
BUTTON_EVENT [dvTP,122]
BUTTON_EVENT [dvTP,123]
{
PUSH:
    {
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-119,0,BGM_SELECT,3)//ROOM 1 INPUT 3
    }
}
BUTTON_EVENT [dvTP,124]//ROOM_COMBINE BGM_SELECT INPUT 4
BUTTON_EVENT [dvTP,125]
BUTTON_EVENT [dvTP,126]
BUTTON_EVENT [dvTP,127]
{
PUSH:
    {
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-123,0,BGM_SELECT,4)//ROOM 1 INPUT 4
    }
}

BUTTON_EVENT [dvTP,132]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[1] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[1] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,133]
{
    PUSH:	bUPDATE_OK[2] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[2] = FALSE}
}
BUTTON_EVENT [dvTP,134]
{
    PUSH:	bUPDATE_OK[3] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[3] = FALSE}
}
BUTTON_EVENT [dvTP,135]
{
    PUSH:	bUPDATE_OK[4] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[4] = FALSE}
}
BUTTON_EVENT [dvTP,136]
{
    PUSH:	bUPDATE_OK[5] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[5] = FALSE}
}
BUTTON_EVENT [dvTP,137]
{
    PUSH:	bUPDATE_OK[6] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[6] = FALSE}
}
BUTTON_EVENT [dvTP,138]
{
    PUSH:	bUPDATE_OK[7] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[7] = FALSE}
}
BUTTON_EVENT [dvTP,139]
{
    PUSH:	bUPDATE_OK[8] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[8] = FALSE}
}
BUTTON_EVENT [dvTP,140]
{
    PUSH:	bUPDATE_OK[9] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[9] = FALSE}
}
BUTTON_EVENT [dvTP,141]
{
    PUSH:	bUPDATE_OK[10] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[10] = FALSE}
}
BUTTON_EVENT [dvTP,142]
{
    PUSH:	bUPDATE_OK[11] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[11] = FALSE}
}
BUTTON_EVENT [dvTP,143]
{
    PUSH:	bUPDATE_OK[12] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[12] = FALSE}
}

BUTTON_EVENT [dvTP,150]//PARTITION 1-4
BUTTON_EVENT [dvTP,151]
BUTTON_EVENT [dvTP,152]
BUTTON_EVENT [dvTP,153]
{
PUSH:
    {
	IF(FB[PUSH_CHANNEL-101][12])//FB[49-52][12]
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-149,0,PARTITION,0)//CLOSE PARTITION
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-149,0,PARTITION,1)//OPEN PARTITION
    }
}
BUTTON_EVENT [dvTP,154]// Buttons 0-9, pause, clear, redial, international, backspace, flash 
BUTTON_EVENT [dvTP,155]
BUTTON_EVENT [dvTP,156]
BUTTON_EVENT [dvTP,157]
BUTTON_EVENT [dvTP,158]
BUTTON_EVENT [dvTP,159]
BUTTON_EVENT [dvTP,160]
BUTTON_EVENT [dvTP,161]
BUTTON_EVENT [dvTP,162]
BUTTON_EVENT [dvTP,163]
BUTTON_EVENT [dvTP,164]
BUTTON_EVENT [dvTP,165]
BUTTON_EVENT [dvTP,166]
BUTTON_EVENT [dvTP,167]
BUTTON_EVENT [dvTP,168]
BUTTON_EVENT [dvTP,169]
BUTTON_EVENT [dvTP,170]
BUTTON_EVENT [dvTP,171]
{
    PUSH:
    {
	LOCAL_VAR INTEGER param;
	param = PUSH_CHANNEL;
	switch(param)
	{
	    case 154:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_1,0);
		break;
	    }
	    case 155:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_2,0);
		break;
	    }
	    case 156:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_3,0);
		break;
	    }
	    case 157:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_4,0);
		break;
	    }
	    case 158:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_5,0);
		break;
	    }
	    case 159:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_6,0);
		break;
	    }
	    case 160:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_7,0);
		break;
	    }
	    case 161:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_8,0);
		break;
	    }
	    case 162:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_9,0);
		break;
	    }
	    case 163:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,ASTERISK,0);
		break;
	    }
	    case 164:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BUTTON_0,0);
		break;
	    }
	    case 165:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,POUND,0);
		break;
	    }
	    case 166:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,PAUSE,0);
		break;
	    }
	    case 167:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,CLEAR,0);
		break;
	    }
	    case 168:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,REDIAL,0);
		break;
	    }
	    case 169:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,INTERNATIONAL,0);
		break;
	    }
	    case 170:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,BACKSPACE,0);
		break;
	    }
	    case 171:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,FLASH,0);
		break;
	    }
	}
	updatePhoneNumber = 1;
    }
}
BUTTON_EVENT [dvTP,172] //Dial HangUP
{
    PUSH:
    {
	CALL 'SET_TELEPHONE'(IO_CARD2,0,0,DIAL_HANGUP,0);
	updatePhoneNumber = 1;
    }


}
BUTTON_EVENT [dvTP,174]// Speed Dial Store
BUTTON_EVENT [dvTP,175]
BUTTON_EVENT [dvTP,176]
BUTTON_EVENT [dvTP,177]
{
    PUSH:
    {
	CALL 'SET_TELEPHONE'(IO_CARD2,PUSH_CHANNEL-173,0,SPEED_DIAL_STORE_SELECT,0);
    }
}
BUTTON_EVENT [dvTP,178]// Speed Dial
BUTTON_EVENT [dvTP,179]
BUTTON_EVENT [dvTP,180]
BUTTON_EVENT [dvTP,181]
{
    PUSH:
    {
	CALL 'SET_TELEPHONE'(IO_CARD2,PUSH_CHANNEL-177,0,SPEED_DIAL_SELECT,0);
	updatePhoneNumber = 1;
    }
}
BUTTON_EVENT [dvTP,182]// Rx and Tx mute
BUTTON_EVENT [dvTP,183]
{
    PUSH:
    {
	if(PUSH_CHANNEL == 182)
	{
	    if(FB[61][12])
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,TX_MUTE,0);
	    else
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,TX_MUTE,1);
	}
	else if(PUSH_CHANNEL == 183)
	{
	    if(FB[62][12])
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,RX_MUTE,0);
	    else
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,RX_MUTE,1);
	}
	
    }
}
BUTTON_EVENT [dvTP,184]// Auto Answer 
BUTTON_EVENT [dvTP,185]
BUTTON_EVENT [dvTP,186]
BUTTON_EVENT [dvTP,187]
BUTTON_EVENT [dvTP,188]
BUTTON_EVENT [dvTP,189]
BUTTON_EVENT [dvTP,190]
BUTTON_EVENT [dvTP,191]
BUTTON_EVENT [dvTP,192]
{
    PUSH:
    {
	LOCAL_VAR INTEGER param;
	param = PUSH_CHANNEL;
	switch(param)
	{
	    case 184:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,0);
		break;
	    }
	    case 185:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,1);
		break;
	    }
	    case 186:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,2);
		break;
	    }
	    case 187:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,3);
		break;
	    }
	    case 188:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,4);
		break;
	    }
	    case 189:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,5);
		break;
	    }
	    case 190:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,6);
		break;
	    }
	    case 191:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,7);
		break;
	    }
	    case 192:
	    {
		CALL 'SET_TELEPHONE'(IO_CARD2,0,0,AUTO_ANSWER,8);
		break;
	    }
	}
    }
}
BUTTON_EVENT [dvTP,193]// Telephone hybrid gains 
{
    PUSH:	bUPDATE_OK[13] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[13] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,194]
{
    PUSH:	bUPDATE_OK[14] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[14] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,195]
{
    PUSH:	bUPDATE_OK[15] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[15] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,196]
{
    PUSH:	bUPDATE_OK[16] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[16] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,197]
{
    PUSH:	bUPDATE_OK[17] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[17] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,301]//setting telephone number to 1-800-555-5555
{
    PUSH:
    {
	call 'SET_NUMBER'(IO_CARD2,'18005555555');
    }
}
BUTTON_EVENT [dvTP,302]//setting telephone number to 18005765256+*#,15648+655
{
    PUSH:
    {
	call 'SET_NUMBER'(IO_CARD2,'18005765256+*#,15648+655');
    }
}
(*****************************************  MIXER    *************************************************)
BUTTON_EVENT [dvTP,198]//MIXER INPUT MUTES
BUTTON_EVENT [dvTP,199]
BUTTON_EVENT [dvTP,200]
BUTTON_EVENT [dvTP,201]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-21][12])
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-197,0,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-197,0,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,202]//MIXER SOLO
BUTTON_EVENT [dvTP,203]
BUTTON_EVENT [dvTP,204]
BUTTON_EVENT [dvTP,205]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-21][12])
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-201,0,SOLO,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,PUSH_CHANNEL-201,0,SOLO,1) 
	}
    }
}
BUTTON_EVENT [dvTP,206]//MIXER OUT MUTE
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-21][12])
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,0,1,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(MR_MIC_MIXER,0,1,MUTE,1) 
	}
    }
}

BUTTON_EVENT [dvTP,207]//INPUT_CARD PHANTOM
BUTTON_EVENT [dvTP,208]
BUTTON_EVENT [dvTP,209]
BUTTON_EVENT [dvTP,210]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-21][12])
	{
	CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,PUSH_CHANNEL-206,0,PHANTOM,0) 
	}
    ELSE
	{
	CALL 'SET_VAL'(IO_CARD1,INPUT_CARD,PUSH_CHANNEL-206,0,PHANTOM,100) 
	}
    }
}


BUTTON_EVENT [dvTP,211]//GAIN - MUTE
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL-21][12])
	{
	CALL 'SET_VAL'(WC_GAIN,GAIN,PUSH_CHANNEL-210,0,MUTE,0)
	}
    ELSE
	{
	CALL 'SET_VAL'(WC_GAIN,GAIN,PUSH_CHANNEL-210,0,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,212]//nGAIN - MUTE
BUTTON_EVENT [dvTP,213]
BUTTON_EVENT [dvTP,214]
BUTTON_EVENT [dvTP,215]
BUTTON_EVENT [dvTP,216]
{
PUSH:
    {
    IF(PUSH_CHANNEL<=215) //THIS ALLOWS PUSH_CHANNEL TO BE INTEGER 1-4 WHICH MATCHES NUMBER OF NGAIN INPUTS
    {
	IF(FB[PUSH_CHANNEL-21][12]) //USING PUSH_CHANNEL TO GET TO PROPER FB[]
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,PUSH_CHANNEL-211,0,MUTE,0)
	}
	ELSE
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,PUSH_CHANNEL-211,0,MUTE,1) 
	}
    }
    ELSE
	IF(FB[PUSH_CHANNEL-21][12])
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,0,PUSH_CHANNEL-215,MUTE,0)
	}
	ELSE
	{
	    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,0,PUSH_CHANNEL-215,MUTE,1) 
	}
    }
}
BUTTON_EVENT [dvTP,217]//SOURCE_SELECTOR
BUTTON_EVENT [dvTP,218]
BUTTON_EVENT [dvTP,219]
BUTTON_EVENT [dvTP,220]
BUTTON_EVENT [dvTP,221]
BUTTON_EVENT [dvTP,222]
BUTTON_EVENT [dvTP,223]
BUTTON_EVENT [dvTP,224]
BUTTON_EVENT [dvTP,225]
{
PUSH:
    {
    CALL 'SET_VAL'(BRIEFING_ROOM,SOURCE_SELECTOR,1,0,ROUTE,PUSH_CHANNEL-217)
    }
}

BUTTON_EVENT [dvTP,226]//SOURCE_MATRIX INPUTS
BUTTON_EVENT [dvTP,227]
BUTTON_EVENT [dvTP,228]
BUTTON_EVENT [dvTP,229]
BUTTON_EVENT [dvTP,230]
BUTTON_EVENT [dvTP,231]
BUTTON_EVENT [dvTP,232]
BUTTON_EVENT [dvTP,233]
{
PUSH:
    {
    CALL 'SET_VAL'(SYSTEM_MATRIX,SOURCE_MATRIX,SMAT_OUT,0,ROUTE,(PUSH_CHANNEL-225))
    }
}
BUTTON_EVENT [dvTP,234]//SOURCE_MATRIX
BUTTON_EVENT [dvTP,235]
BUTTON_EVENT [dvTP,236]
BUTTON_EVENT [dvTP,237]
BUTTON_EVENT [dvTP,238]
BUTTON_EVENT [dvTP,239]
BUTTON_EVENT [dvTP,240]
BUTTON_EVENT [dvTP,241]
{
PUSH:
    {
    SMAT_OUT = (PUSH_CHANNEL-233)
    //ON[dvTP,PUSH_CHANNEL]
    }
}



(* SAMPLE OF CONTROLLING MASTER GAIN FADER ON A MIXER USE A NON-ACTIVE BARGRAPH.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN INPUT SPECIFIES YOU WANT TO CONTROL OUTPUT FADER
BUTTON_EVENT [dvTP,242]
{
PUSH: //RAMP UP
    {
    //CALL 'SET_VAL'(DANCE_MIXER,MIXER,0,L,UNMUTE) //OUTPUT LEFT UNMUTE (if mono then master out mute)
    
    IF (MasterOut_Vol < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol + GAIN_STEP_PER;
	FB[209][10] = TYPE_CAST(MASTEROUT_VOL);
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,MASTEROUT_VOL)
	
	}
    }
HOLD[1,REPEAT]:
    {
    IF (MasterOut_Vol < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol + GAIN_STEP_PER;
	FB[209][10] = TYPE_CAST(MASTEROUT_VOL);
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,masterout_vol)
	
	}
    }

}

(* SAMPLE OF CONTROLLING MASTER GAIN FADER ON A MIXER.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN INPUT SPECIFIES YOU WANT TO CONTROL OUTPUT FADER
BUTTON_EVENT [dvTP,243]
{
PUSH://RAMP DOWN
    {
    //CALL 'SET_VAL'(DANCE_MIXER,MIXER,0,L,UNMUTE) //OUTPUT LEFT UNMUTE (if mono then master out mute)
    
    IF (MasterOut_Vol > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol - GAIN_STEP_PER;
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,MasterOut_Vol)
	FB[209][10] = TYPE_CAST(MASTEROUT_VOL);
	}
    }
HOLD[1,REPEAT]:
    {
    IF (MasterOut_Vol > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
	{
	MasterOut_Vol = MasterOut_Vol - GAIN_STEP_PER;
	CALL 'SET_GAIN%'(WC_GAIN,GAIN,1,0,MasterOut_Vol)
	FB[209][10] = TYPE_CAST(MASTEROUT_VOL);
	}
    }

}
BUTTON_EVENT [dvTP,244]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[18] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[18] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,245]
{
    PUSH:	bUPDATE_OK[19] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[19] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,246]
{
    PUSH:	bUPDATE_OK[20] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[20] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,247]
{
    PUSH:	bUPDATE_OK[21] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[21] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,248]
{
    PUSH:	bUPDATE_OK[22] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[22] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,249]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[23] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[23] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,250]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[24] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[24] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,251]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[25] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[25] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,252]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[26] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[26] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,253]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[27] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[27] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,254]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[28] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[28] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,255]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[29] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[29] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,256]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[30] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[30] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,257]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[31] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[31] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,258]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[32] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[32] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,259]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[33] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[33] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,260]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[34] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[34] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,261]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[35] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[35] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,262]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[36] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[36] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,263]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[37] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[37] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,264]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[38] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[38] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,265]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[39] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[39] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,266]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[40] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[40] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,267]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[41] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[41] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,268]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[42] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[42] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,269]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[43] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[43] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,270]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[44] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[44] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,271]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[45] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[45] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,272]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[46] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[46] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,273]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[47] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[47] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,274]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[48] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[48] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,275]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[49] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[49] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,276]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[50] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[50] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,277]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[51] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[51] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,278]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[52] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[52] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,279]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[53] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[53] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,280]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[54] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[54] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,281]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[55] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[55] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,282]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[56] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[56] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,283]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[57] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[57] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,284]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[58] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[58] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,285]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[59] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[59] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,286]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[60] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[60] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,287]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[61] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[61] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,288]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[62] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[62] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,289]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[63] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[63] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,290]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[64] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[64] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,291]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[65] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[65] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,292]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[66] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[66] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,293]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[67] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[67] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,294]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[68] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[68] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,295]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[69] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[69] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,296]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[70] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[70] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,297]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[71] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[71] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,298]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[72] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[72] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,299]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[73] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[73] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,300]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[74] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[74] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}


TIMELINE_EVENT[TL1]//FEEDBACK TIMELINE
{
    //FOR ALL DISCRETE SV'S (MUTES, ROUTES, ETC) THE 12TH BYTE <FB[][12]> HOLDS THE ZERO OR ONE (MUTE OR UNMUTE) STATE OF STATE VARIABLE
    //FOR ALL GAIN% SV'S THE 10TH BYTE <FB[][10]> WILL HOLD THE VALUE OF THE FADER IN PERCENT <0-100>. THE 11TH AND 12TH ELEMENT IS THE FRACTIONAL (DECIMAL) VALUE (IE 67.003%) USED ONLY FOR ROUNDING TO THE NEAREST INTEGER FOR THIS SAMPLE PROGAM. THE PROGRAMMER CAN MODIFY TO USE THIS EXTRA RESOLUTION IF DESIRED
    //SEE HELP FILE FOR COMPLETE FB[][] STRUCTURE
    
    
    [dvTP,100] = FB[21][12];//ROOM_COMBINE SOURCE_MUTE
    [dvTP,101] = FB[22][12];
    [dvTP,102] = FB[23][12];
    [dvTP,103] = FB[24][12];
    [dvTP,104] = FB[25][12];//ROOM_COMBINE BGM_MUTE
    [dvTP,105] = FB[26][12];
    [dvTP,106] = FB[27][12];
    [dvTP,107] = FB[28][12];
    [dvTP,108] = FB[29][12];//ROOM_COMBINE MASTER_MUTE
    [dvTP,109] = FB[30][12];
    [dvTP,110] = FB[31][12];
    [dvTP,111] = FB[32][12];
    //[dvTP,112] = FB[33][12] = 0;//ROOM_COMBINE ROOM1 BGM_SELECT NO SOURCE
    [dvTP,112] = FB[33][12] = 1;//ROOM_COMBINE ROOM1 BGM_SELECT SOURCE
    [dvTP,116] = FB[33][12] = 2;
    [dvTP,120] = FB[33][12] = 3;
    [dvTP,124] = FB[33][12] = 4;
    [dvTP,113] = FB[34][12] = 1;//ROOM_COMBINE ROOM2 BGM_SELECT SOURCE 
    [dvTP,117] = FB[34][12] = 2;
    [dvTP,121] = FB[34][12] = 3;
    [dvTP,125] = FB[34][12] = 4;
    [dvTP,114] = FB[35][12] = 1;//ROOM_COMBINE ROOM3 BGM_SELECT SOURCE 
    [dvTP,118] = FB[35][12] = 2;
    [dvTP,122] = FB[35][12] = 3;
    [dvTP,126] = FB[35][12] = 4;
    [dvTP,115] = FB[36][12] = 1;//ROOM_COMBINE ROOM4 BGM_SELECT SOURCE 
    [dvTP,119] = FB[36][12] = 2;
    [dvTP,123] = FB[36][12] = 3;
    [dvTP,127] = FB[36][12] = 4;
    [dvTP,150] = FB[49][12];//ROOM_COMBINE PARTITION 1
    [dvTP,151] = FB[50][12];//ROOM_COMBINE PARTITION 2
    [dvTP,152] = FB[51][12];//ROOM_COMBINE PARTITION 3
    [dvTP,153] = FB[52][12];//ROOM_COMBINE PARTITION 4
    
    IF(updatePhoneNumber){
	wait 3 // wait a little bit of time so that the command is sent and returned before updating the phone number.
	{
	    SEND_COMMAND dvTP,"'@TXT',1,DISPLAY_NUMBER(FB[57],FB[58],FB[59],FB[60])"
	    updatePhoneNumber = 0;
	}
    }
    [dvTP,172] = FB[65][12]//Dial HangUP
    [dvTP,173] = FB[63][12]//Incoming CALL
    [dvTP,182] = FB[61][12]// Tx mute
    [dvTP,183] = FB[62][12]// Rx mute
    [dvTP,184] = FB[64][12] = 0 // Auto Answer 
    [dvTP,185] = FB[64][12] = 1 // Auto Answer
    [dvTP,186] = FB[64][12] = 2 // Auto Answer
    [dvTP,187] = FB[64][12] = 3 // Auto Answer
    [dvTP,188] = FB[64][12] = 4 // Auto Answer
    [dvTP,189] = FB[64][12] = 5 // Auto Answer
    [dvTP,190] = FB[64][12] = 6 // Auto Answer
    [dvTP,191] = FB[64][12] = 7 // Auto Answer
    [dvTP,192] = FB[64][12] = 8 // Auto Answer

    
(********************************   DYNAMIC TOUCH PANEL COMMANDS FOR ROOM COMBINE GROUP COLORS   *************)
    IF (iRM1_GROUP != FB[53][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[53][12] = 0)//ROOM_COMBINE ROOM1 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-15,0,1'" //CHANGE ROOM1 BUTTON TO STATE 1
	ELSE IF (FB[53][12] = 1)//ROOM_COMBINE ROOM1 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-15,0,2'" //CHANGE ROOM1 BUTTON TO STATE 2
	ELSE IF (FB[53][12] = 2)//ROOM_COMBINE ROOM1 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-15,0,3'" //CHANGE ROOM1 BUTTON TO STATE 3
	iRm1_Group = FB[53][12];
    }
    
    IF (iRM2_GROUP != FB[54][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[54][12] = 0)//ROOM_COMBINE ROOM2 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-16,0,1'" //CHANGE ROOM2 BUTTON TO STATE 1
	ELSE IF (FB[54][12] = 1)//ROOM_COMBINE ROOM2 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-16,0,2'" //CHANGE ROOM2 BUTTON TO STATE 2
	ELSE IF (FB[54][12] = 2)//ROOM_COMBINE ROOM2 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-16,0,3'" //CHANGE ROOM2 BUTTON TO STATE 3
	iRM2_GROUP = FB[54][12];
    }
    
    IF (iRM3_GROUP != FB[55][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[55][12] = 0)//ROOM_COMBINE ROOM3 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-17,0,1'" //CHANGE ROOM3 BUTTON TO STATE 1
	ELSE IF (FB[55][12] = 1)//ROOM_COMBINE ROOM3 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-17,0,2'" //CHANGE ROOM3 BUTTON TO STATE 2
	ELSE IF (FB[55][12] = 2)//ROOM_COMBINE ROOM3 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-17,0,3'" //CHANGE ROOM3 BUTTON TO STATE 3
	iRM3_GROUP = FB[55][12];
    }

    IF (iRM4_GROUP != FB[56][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[56][12] = 0)//ROOM_COMBINE ROOM4 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-18,0,1'" //CHANGE ROOM4 BUTTON TO STATE 1
	ELSE IF (FB[56][12] = 1)//ROOM_COMBINE ROOM4 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-18,0,2'" //CHANGE ROOM4 BUTTON TO STATE 2
	ELSE IF (FB[56][12] = 2)//ROOM_COMBINE ROOM4 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-18,0,3'" //CHANGE ROOM4 BUTTON TO STATE 3
	iRM4_GROUP = FB[56][12]
    }
(************************************************************************************************************)
    
    



    
    
(***************************************************************)
    (* TO UPDATE VOLUME BAR GRAPHS WHEN USING ACTIVE BAR GRAPH*)(*SEE LEVEL_EVENT AS WELL*)
    //BUTTON_EVENT 132-143 IS WHERE THESE VARS ARE SET.  EACH VAR IS THE PUSH EVENT ASSOCIATED WITH AN ACTIVE BARGRAPH
    //THE 10TH ELEMENT (FB[][10]) IS THE PERCENT VALUE (0-100) THAT IS SENT TO THE BARGRAPH. THE 11TH AND 12TH ELEMENT IS THE FRACTIONAL (DECIMAL) VALUE (IE 67.003%) USED ONLY FOR ROUNDING TO THE NEAREST INTEGER FOR THIS SAMPLE PROGAM. THE PROGRAMMER CAN MODIFY TO USE THIS EXTRA RESOLUTION IF DESIRED

    IF (!bUPDATE_OK[1])//UPDATE ACTIVE BARGRAPH FEEDBACK FROM NON AMX DEVICE (ie LONDON ARCHITECT, 10K POT, ETC)
	SEND_LEVEL dvTP,2,TYPE_CAST(MID_STRING(FB[37],10,1))//SOURCE_GAIN ROOM1
    IF (!bUPDATE_OK[2])
	SEND_LEVEL dvTP,3,TYPE_CAST(MID_STRING(FB[38],10,1))//SOURCE_GAIN ROOM2
    IF (!bUPDATE_OK[3])
	SEND_LEVEL dvTP,4,TYPE_CAST(MID_STRING(FB[39],10,1))//SOURCE_GAIN ROOM3
    IF (!bUPDATE_OK[4])
	SEND_LEVEL dvTP,5,TYPE_CAST(MID_STRING(FB[40],10,1))//SOURCE_GAIN ROOM4
    IF (!bUPDATE_OK[5])
	SEND_LEVEL dvTP,6,TYPE_CAST(MID_STRING(FB[41],10,1))//BGM_GAIN
    IF (!bUPDATE_OK[6])
	SEND_LEVEL dvTP,7,TYPE_CAST(MID_STRING(FB[42],10,1))
    IF (!bUPDATE_OK[7])
	SEND_LEVEL dvTP,8,TYPE_CAST(MID_STRING(FB[43],10,1))
    IF (!bUPDATE_OK[8])
	SEND_LEVEL dvTP,9,TYPE_CAST(MID_STRING(FB[44],10,1))
    IF (!bUPDATE_OK[9])
	SEND_LEVEL dvTP,10,TYPE_CAST(MID_STRING(FB[45],10,1))//MASTER_GAIN
    IF (!bUPDATE_OK[10])
	SEND_LEVEL dvTP,11,TYPE_CAST(MID_STRING(FB[46],10,1))
    IF (!bUPDATE_OK[11])
	SEND_LEVEL dvTP,12,TYPE_CAST(MID_STRING(FB[47],10,1))
    IF (!bUPDATE_OK[12])
	SEND_LEVEL dvTP,13,TYPE_CAST(MID_STRING(FB[48],10,1))
    IF (!bUPDATE_OK[13])
	SEND_LEVEL dvTP,14,TYPE_CAST(MID_STRING(FB[66],10,1))
    IF (!bUPDATE_OK[14])
	SEND_LEVEL dvTP,15,TYPE_CAST(MID_STRING(FB[67],10,1))
    IF (!bUPDATE_OK[15])
	SEND_LEVEL dvTP,16,TYPE_CAST(MID_STRING(FB[68],10,1))
    IF (!bUPDATE_OK[16])
	SEND_LEVEL dvTP,17,TYPE_CAST(MID_STRING(FB[69],10,1))
    IF (!bUPDATE_OK[17])
	SEND_LEVEL dvTP,18,TYPE_CAST(MID_STRING(FB[70],10,1))
    IF (!bUPDATE_OK[18])
    {
	SWITCH(mmix_out)
	{
	    CASE 1 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[210],10,1))//matrix mixer
	    CASE 2 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[211],10,1))//matrix mixer
	    CASE 3 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[212],10,1))//matrix mixer
	    CASE 4 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[213],10,1))//matrix mixer
	    CASE 5 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[214],10,1))//matrix mixer
	    CASE 6 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[215],10,1))//matrix mixer
	    CASE 7 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[216],10,1))//matrix mixer
	    CASE 8 : SEND_LEVEL dvTP,19,TYPE_CAST(MID_STRING(FB[217],10,1))//matrix mixer
	}
	
    }
    IF (!bUPDATE_OK[19])
	SEND_LEVEL dvTP,20,TYPE_CAST(MID_STRING(FB[173],10,1))//automixer gains
    IF (!bUPDATE_OK[20])
	SEND_LEVEL dvTP,21,TYPE_CAST(MID_STRING(FB[174],10,1))
    IF (!bUPDATE_OK[21])
	SEND_LEVEL dvTP,22,TYPE_CAST(MID_STRING(FB[175],10,1))
    IF (!bUPDATE_OK[22])
	SEND_LEVEL dvTP,23,TYPE_CAST(MID_STRING(FB[176],10,1))
    IF (!bUPDATE_OK[23])
	SEND_LEVEL dvTP,24,TYPE_CAST(MID_STRING(FB[218],10,1))
    IF (!bUPDATE_OK[24])
	SEND_LEVEL dvTP,25,TYPE_CAST(MID_STRING(FB[219],10,1))
    IF (!bUPDATE_OK[25])
	SEND_LEVEL dvTP,26,TYPE_CAST(MID_STRING(FB[220],10,1))
    IF (!bUPDATE_OK[26])
	SEND_LEVEL dvTP,27,TYPE_CAST(MID_STRING(FB[221],10,1))
    IF (!bUPDATE_OK[27])
	SEND_LEVEL dvTP,28,TYPE_CAST(MID_STRING(FB[222],10,1))
    IF (!bUPDATE_OK[28])
	SEND_LEVEL dvTP,29,TYPE_CAST(MID_STRING(FB[223],10,1))
    IF (!bUPDATE_OK[29])
	SEND_LEVEL dvTP,30,TYPE_CAST(MID_STRING(FB[224],10,1))
    IF (!bUPDATE_OK[30])
	SEND_LEVEL dvTP,31,TYPE_CAST(MID_STRING(FB[225],10,1))
    IF (!bUPDATE_OK[31])
	SEND_LEVEL dvTP,32,TYPE_CAST(MID_STRING(FB[226],10,1))
    IF (!bUPDATE_OK[32])
	SEND_LEVEL dvTP,33,TYPE_CAST(MID_STRING(FB[227],10,1))
    IF (!bUPDATE_OK[33])
	SEND_LEVEL dvTP,34,TYPE_CAST(MID_STRING(FB[228],10,1))
    IF (!bUPDATE_OK[34])
	SEND_LEVEL dvTP,35,TYPE_CAST(MID_STRING(FB[229],10,1))
    IF (!bUPDATE_OK[35])
	SEND_LEVEL dvTP,36,TYPE_CAST(MID_STRING(FB[230],10,1))
    IF (!bUPDATE_OK[36])
	SEND_LEVEL dvTP,37,TYPE_CAST(MID_STRING(FB[231],10,1))
    IF (!bUPDATE_OK[37])
	SEND_LEVEL dvTP,38,TYPE_CAST(MID_STRING(FB[232],10,1))
    IF (!bUPDATE_OK[38])
	SEND_LEVEL dvTP,39,TYPE_CAST(MID_STRING(FB[233],10,1))
    IF (!bUPDATE_OK[39])
	SEND_LEVEL dvTP,40,TYPE_CAST(MID_STRING(FB[234],10,1))
    IF (!bUPDATE_OK[40])
	SEND_LEVEL dvTP,41,TYPE_CAST(MID_STRING(FB[235],10,1))
    IF (!bUPDATE_OK[41])
	SEND_LEVEL dvTP,42,TYPE_CAST(MID_STRING(FB[236],10,1))//mixer gains
    IF (!bUPDATE_OK[42])
	SEND_LEVEL dvTP,43,TYPE_CAST(MID_STRING(FB[237],10,1))
    IF (!bUPDATE_OK[43])
	SEND_LEVEL dvTP,44,TYPE_CAST(MID_STRING(FB[238],10,1))
    IF (!bUPDATE_OK[44])
	SEND_LEVEL dvTP,45,TYPE_CAST(MID_STRING(FB[239],10,1))
    IF (!bUPDATE_OK[45])
	SEND_LEVEL dvTP,46,TYPE_CAST(MID_STRING(FB[240],10,1))
    IF (!bUPDATE_OK[46])
	SEND_LEVEL dvTP,47,TYPE_CAST(MID_STRING(FB[241],10,1))// input card
    IF (!bUPDATE_OK[47])
	SEND_LEVEL dvTP,48,TYPE_CAST(MID_STRING(FB[242],10,1))
    IF (!bUPDATE_OK[48])
	SEND_LEVEL dvTP,49,TYPE_CAST(MID_STRING(FB[243],10,1))
    IF (!bUPDATE_OK[49])
	SEND_LEVEL dvTP,50,TYPE_CAST(MID_STRING(FB[244],10,1))
    IF (!bUPDATE_OK[50])
	SEND_LEVEL dvTP,51,TYPE_CAST(MID_STRING(FB[245],10,1))
    IF (!bUPDATE_OK[51])
	SEND_LEVEL dvTP,52,TYPE_CAST(MID_STRING(FB[246],10,1))
    IF (!bUPDATE_OK[52])
	SEND_LEVEL dvTP,53,TYPE_CAST(MID_STRING(FB[247],10,1))
    IF (!bUPDATE_OK[53])
	SEND_LEVEL dvTP,54,TYPE_CAST(MID_STRING(FB[248],10,1))
    IF (!bUPDATE_OK[54])
	SEND_LEVEL dvTP,55,TYPE_CAST(MID_STRING(FB[249],10,1))
    IF (!bUPDATE_OK[55])
	SEND_LEVEL dvTP,56,TYPE_CAST(MID_STRING(FB[250],10,1))
    IF (!bUPDATE_OK[56])
	SEND_LEVEL dvTP,57,TYPE_CAST(MID_STRING(FB[251],10,1))
    IF (!bUPDATE_OK[57])
	SEND_LEVEL dvTP,58,TYPE_CAST(MID_STRING(FB[252],10,1))
    IF (!bUPDATE_OK[58])
	SEND_LEVEL dvTP,59,TYPE_CAST(MID_STRING(FB[253],10,1))//N GAIN
    IF (!bUPDATE_OK[59])
	SEND_LEVEL dvTP,60,TYPE_CAST(MID_STRING(FB[254],10,1))
    IF (!bUPDATE_OK[60])
	SEND_LEVEL dvTP,61,TYPE_CAST(MID_STRING(FB[255],10,1))
    IF (!bUPDATE_OK[61])
	SEND_LEVEL dvTP,62,TYPE_CAST(MID_STRING(FB[256],10,1))
    IF (!bUPDATE_OK[62])
	SEND_LEVEL dvTP,63,TYPE_CAST(MID_STRING(FB[257],10,1))
    IF (!bUPDATE_OK[63])
	SEND_LEVEL dvTP,64,TYPE_CAST(MID_STRING(FB[258],10,1))// output card
    IF (!bUPDATE_OK[64])
	SEND_LEVEL dvTP,65,TYPE_CAST(MID_STRING(FB[259],10,1))
    IF (!bUPDATE_OK[65])
	SEND_LEVEL dvTP,66,TYPE_CAST(MID_STRING(FB[260],10,1))
    IF (!bUPDATE_OK[66])
	SEND_LEVEL dvTP,67,TYPE_CAST(MID_STRING(FB[261],10,1))
    IF (!bUPDATE_OK[67])
	SEND_LEVEL dvTP,68,TYPE_CAST(MID_STRING(FB[262],10,1))
    IF (!bUPDATE_OK[68])
	SEND_LEVEL dvTP,69,TYPE_CAST(MID_STRING(FB[263],10,1))
    IF (!bUPDATE_OK[69])
	SEND_LEVEL dvTP,70,TYPE_CAST(MID_STRING(FB[264],10,1))
    IF (!bUPDATE_OK[70])
	SEND_LEVEL dvTP,71,TYPE_CAST(MID_STRING(FB[265],10,1))
    IF (!bUPDATE_OK[71])
	SEND_LEVEL dvTP,72,TYPE_CAST(MID_STRING(FB[266],10,1))
    IF (!bUPDATE_OK[72])
	SEND_LEVEL dvTP,73,TYPE_CAST(MID_STRING(FB[267],10,1))
    IF (!bUPDATE_OK[73])
	SEND_LEVEL dvTP,74,TYPE_CAST(MID_STRING(FB[268],10,1))
    IF (!bUPDATE_OK[74])
	SEND_LEVEL dvTP,75,TYPE_CAST(MID_STRING(FB[269],10,1))
    (*******************************************************************)
    
    
    (*********** MATRIX MIXER ***********************)//77-140
    MMIX_FB = ((MMIX_OUT-1)*8);
    [dvTP,15] = FB[MMIX_FB+77][12];
    [dvTP,16] = FB[MMIX_FB+78][12];
    [dvTP,17] = FB[MMIX_FB+79][12];
    [dvTP,18] = FB[MMIX_FB+80][12];
    [dvTP,19] = FB[MMIX_FB+81][12];
    [dvTP,20] = FB[MMIX_FB+82][12];
    [dvTP,21] = FB[MMIX_FB+83][12];
    [dvTP,22] = FB[MMIX_FB+84][12];
    

    (*********** MATRIX MIXER output ***********************)
    
    [dvTP,23] = MMIX_OUT = 1;
    [dvTP,24] = MMIX_OUT = 2;
    [dvTP,25] = MMIX_OUT = 3;
    [dvTP,26] = MMIX_OUT = 4;
    [dvTP,27] = MMIX_OUT = 5;
    [dvTP,28] = MMIX_OUT = 6;
    [dvTP,29] = MMIX_OUT = 7;
    [dvTP,30] = MMIX_OUT = 8;
    
    (******** MATRIX ROUTER *********************)
    [dvTP,31] = FB[141][12];
    [dvTP,32] = FB[142][12];
    [dvTP,33] = FB[143][12]
    [dvTP,34] = FB[144][12];
    [dvTP,35] = FB[145][12];
    [dvTP,36] = FB[146][12];
    [dvTP,37] = FB[147][12];
    [dvTP,38] = FB[148][12];
    [dvTP,39] = FB[149][12];
    [dvTP,40] = FB[150][12];
    [dvTP,41] = FB[151][12];
    [dvTP,42] = FB[152][12];
    [dvTP,43] = FB[153][12];
    [dvTP,44] = FB[154][12];
    [dvTP,45] = FB[155][12];
    [dvTP,46] = FB[156][12];
    
    (****************  AUTOMIXER ************************************)
    [dvTP,50] = FB[1][12];//REAL FEEDBACK - THE 12TH BYTE HOLDS THE ZERO OR ONE (MUTE OR UNMUTE) STATE OF STATE VARIABLE
    [dvTP,51] = FB[2][12];//INPUT MUTES
    [dvTP,52] = FB[3][12];
    [dvTP,53] = FB[4][12];
    [dvTP,86] = FB[5][12];//MASTER MUTE
    [dvTP,87] = FB[6][12];
    [dvTP,88] = FB[7][12];//GROUP MUTE
    [dvTP,89] = FB[8][12];
    [dvTP,90] = FB[9][12];
    [dvTP,91] = FB[10][12];
    [dvTP,92] = FB[11][12];//AUX OUT MUTES
    [dvTP,93] = FB[12][12];
    [dvTP,94] = FB[13][12];
    [dvTP,95] = FB[14][12];
    [dvTP,54] = FB[15][12];//SOLO
    [dvTP,55] = FB[16][12];
    [dvTP,56] = FB[17][12];
    [dvTP,57] = FB[18][12];
    
    [dvTP,62] = FB[19][12];//AUTO
    [dvTP,63] = FB[20][12];
    [dvTP,64] = FB[71][12];
    [dvTP,65] = FB[72][12];
    [dvTP,66] = FB[73][12];//OVERRIDE
    [dvTP,67] = FB[74][12];
    [dvTP,68] = FB[75][12];
    [dvTP,69] = FB[76][12];
    [dvTP,70] = FB[157][12];//GROUP INPUT 1
    [dvTP,71] = FB[158][12];
    [dvTP,72] = FB[159][12];
    [dvTP,73] = FB[160][12];
    [dvTP,74] = FB[161][12];//GROUP INPUT 2
    [dvTP,75] = FB[162][12];
    [dvTP,76] = FB[163][12];
    [dvTP,77] = FB[164][12];
    [dvTP,78] = FB[165][12];//GROUP INPUT 3
    [dvTP,79] = FB[166][12];
    [dvTP,80] = FB[167][12];
    [dvTP,81] = FB[168][12];
    [dvTP,82] = FB[169][12];//GROUP INPUT 4
    [dvTP,83] = FB[170][12];
    [dvTP,84] = FB[171][12];
    [dvTP,85] = FB[172][12];
    
    (************************* MIXER **************************************)
    [dvTP,198] = FB[177][12];//MIXER INPUT MUTES
    [dvTP,199] = FB[178][12];
    [dvTP,200] = FB[179][12];
    [dvTP,201] = FB[180][12];
    [dvTP,202] = FB[181][12];//MIXER SOLO
    [dvTP,203] = FB[182][12];
    [dvTP,204] = FB[183][12];
    [dvTP,205] = FB[184][12];
    [dvTP,206] = FB[185][12];//MIXER MASTER MUTE
    
    (************************* INPUT_CARD *************************************)
    [dvTP,207] = FB[186][10];//INPUT_CARD PHANTOM
    [dvTP,208] = FB[187][10];
    [dvTP,209] = FB[188][10];
    [dvTP,210] = FB[189][10];
    
    (************************* GAIN ***********************************)
    [dvTP,211] = FB[190][12];//MUTE
    
    (*********************** N GAIN *************************************)
    [dvTP,212] = FB[191][12];
    [dvTP,213] = FB[192][12];
    [dvTP,214] = FB[193][12];
    [dvTP,215] = FB[194][12];
    [dvTP,216] = FB[195][12];
    (*********************** SOURCE_SELECTOR *************************)
    [dvTP,217] = FB[196][12] = 0;
    [dvTP,218] = FB[196][12] = 1;
    [dvTP,219] = FB[196][12] = 2;
    [dvTP,220] = FB[196][12] = 3;
    [dvTP,221] = FB[196][12] = 4;
    [dvTP,222] = FB[196][12] = 5;
    [dvTP,223] = FB[196][12] = 6;
    [dvTP,224] = FB[196][12] = 7;
    [dvTP,225] = FB[196][12] = 8;
    
    (************************ SOURCE_MATRIX Input ****************************)
    SMAT_FB = (SMAT_OUT-1);
    [dvTP,226] = FB[SMAT_FB+197][12] = 1;
    [dvTP,227] = FB[SMAT_FB+197][12] = 2;
    [dvTP,228] = FB[SMAT_FB+197][12] = 3;
    [dvTP,229] = FB[SMAT_FB+197][12] = 4;
    [dvTP,230] = FB[SMAT_FB+197][12] = 5;
    [dvTP,231] = FB[SMAT_FB+197][12] = 6;
    [dvTP,232] = FB[SMAT_FB+197][12] = 7;
    [dvTP,233] = FB[SMAT_FB+197][12] = 8;
    
    (************************ SOURCE_MATRIX output ****************************)
    [dvTP,234] = SMAT_OUT = 1;
    [dvTP,235] = SMAT_OUT = 2;
    [dvTP,236] = SMAT_OUT = 3;
    [dvTP,237] = SMAT_OUT = 4;
    [dvTP,238] = SMAT_OUT = 5;
    [dvTP,239] = SMAT_OUT = 6;
    [dvTP,240] = SMAT_OUT = 7;
    [dvTP,241] = SMAT_OUT = 8;
    
    (*********************** OUTPUT_CARD ***********************************)
    
    
    (* FEEDBACK AFTER SUBSCRIBING TO A METER *)
    IF(menuOUTPUTCARD)
    {
	METER_FB_infocomm =TYPE_CAST(MID_STRING(FB[205],10,1)); //FB[158] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO;FB[][10] HOLDS VALUE OF PERCENT
	SEND_LEVEL dvTP,63,METER_FB_infocomm;
	
	METER_FB_infocomm = TYPE_CAST(MID_STRING(FB[206],10,1)); //FB[159] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO;FB[][10] HOLDS VALUE OF PERCENT
	SEND_LEVEL dvTP,64,METER_FB_infocomm;
    }
    
    (******************************** GAIN VOLUME  ********************************)
    (* TO UPDATE VOLUME BAR GRAPHS WHEN USING A NON ACTIVE BAR GRAPH*) //SEE BUTTON_EVENT 13,14
    (*IF USING SUBSCRIBE PERCENT!!!*)
    
    MASTEROUT_VOL = TYPE_CAST(MID_STRING(FB[209],10,1)); //FB[162] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO
    SEND_LEVEL dvTP, 76, MASTEROUT_VOL;
}

TIMELINE_EVENT[TL2]//FEEDBACK TIMELINE
{
    SEND_STRING dvSOUNDWEB,"STX,ETX"// this command will only work for a serial connection.
    if(!SIX_RECEIVED)
    {
	if(subscribed)
	    resubscribe = 1;
    }
    else
    {
	SIX_RECEIVED = 0
	if(resubscribe)
	{
	    resubscribe = 0
	    SUBSCRIBE_ALL()
	}
    }
}


(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

//ALL FEEDBACK HANDLED IN TIMELINE[TL1] EVENT FOR BETTER PERFORMANCE (AS REQUESTED BY AMX PERSONNEL)
//THE PROGRAMMER CAN ELIMINATE THE TIMELINE AND PLACE ALL FEEDBACK HERE IF THEY ARE MORE COMFORTABLE WITH THAT METHOD AS SHOWN IN THE INFOCOMM 06 FILE




(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)




